# Generated by Django 2.2.10 on 2020-08-12 16:50

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import momopay.classes.enum


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Credit',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('current_balance', models.DecimalField(decimal_places=4, default=0, max_digits=14)),
                ('currency', models.CharField(default='GHS', max_length=10)),
                ('total_credited', models.DecimalField(decimal_places=4, default=0, max_digits=14)),
                ('total_used', models.DecimalField(decimal_places=4, default=0, max_digits=14)),
                ('time_created', models.DateTimeField(auto_now_add=True)),
                ('time_updated', models.DateTimeField(auto_now=True)),
                ('user', models.OneToOneField(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='CreditTransaction',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('transaction_id', models.CharField(max_length=255, unique=True)),
                ('transaction_amount', models.DecimalField(decimal_places=4, max_digits=14)),
                ('balance_before', models.DecimalField(decimal_places=4, max_digits=14)),
                ('balance_after', models.DecimalField(decimal_places=4, max_digits=14)),
                ('medium', models.IntegerField(choices=[(0, 'CREDIT'), (1, 'MOMO'), (2, 'CASH'), (3, 'CHEQUE'), (4, 'DIRECT_DEPOSIT'), (5, 'GIFT'), (6, 'SYSTEM'), (7, 'MOMO_API')])),
                ('transaction_type', models.IntegerField(choices=[(0, 'CREDIT'), (1, 'DEBIT'), (2, 'DEBITREVERSE'), (3, 'CREDITREVERSE')])),
                ('extra_info', models.CharField(max_length=255, null=True)),
                ('channel', models.IntegerField(choices=[(0, 'WEB'), (1, 'API')])),
                ('time_created', models.DateTimeField(auto_now_add=True)),
                ('time_updated', models.DateTimeField(auto_now=True)),
                ('credit', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='momopay.Credit')),
                ('transacted_by', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='MomoTransaction',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('amount', models.DecimalField(decimal_places=4, max_digits=10)),
                ('network', models.IntegerField(choices=[(0, 'MTN'), (1, 'VODAFONE'), (2, 'AIRTELTIGO'), (3, 'GLO'), (4, 'EXPRESSO'), (5, 'UNKNOWN')])),
                ('msisdn', models.CharField(max_length=20)),
                ('status', models.IntegerField(choices=[(1, 'ACTIVE'), (2, 'PENDING'), (3, 'DELETED'), (4, 'COMPLETED'), (5, 'FAILED'), (6, 'PROCESSING'), (7, 'DISAPPROVED'), (8, 'PAYMENTPENDING')], default=momopay.classes.enum.StatusTypes(2))),
                ('info_sent', models.TextField()),
                ('initial_callback', models.CharField(max_length=255, null=True)),
                ('final_callback', models.CharField(max_length=255, null=True)),
                ('time_created', models.DateTimeField(auto_now_add=True)),
                ('time_updated', models.DateTimeField(auto_now=True)),
                ('order_id', models.CharField(max_length=50, unique=True)),
                ('ext_id', models.CharField(max_length=50, null=True)),
                ('channel', models.IntegerField(choices=[(0, 'WEB'), (1, 'API')], null=True)),
                ('credit_transaction', models.OneToOneField(null=True, on_delete=django.db.models.deletion.CASCADE, to='momopay.CreditTransaction')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
    ]
